untyped
global function primrosePrecache
global function OnWeaponPrimaryAttack_weapon_primrose
global function OnProjectileCollision_weapon_primrose
global function OnWeaponReload_weapon_primrose

const array<asset> particlesToPrecache = [
	$"wpn_mflash_snp_hmn_smoke_side_FP",
	$"wpn_mflash_snp_hmn_smoke_side",
	$"P_projectile_lstar",
	$"P_doubletake_proj",
	$"P_xo_armor_impact",
	$"P_muz_TPA",
	$"titan_sniper_CH_refract",
	$"titan_sniper_CH_trail_arc",
	$"titan_sniper_CH_rope_smoke",
	$"P_impact_dragonbreath",
	$"P_wpn_mflash_dbltake_FP_burn",
	$"P_xo_EMP",
	$"wpn_arc_cannon_beam",
	$"P_impact_lasercannon_default",
	$"impact_arc_cannon_titan_red",
	$"impact_ArcCannon_CH_bits_red",
	$"impact_ArcCannon_CH_glow_P_red",
	$"impact_ArcCannon_CH_glow_FP_red",
	$"lstar_trail_CH_spark"
	//$"primrose_sprite_vortex"
]

const array <asset> projectileTrails = [
	$"P_projectile_lstar",
	$"P_doubletake_proj"
]

const array <asset> muzzleFlashes = [
	$"P_muz_lstar",
	$"P_wpn_mflash_dbltake"
]

const array <asset> empRingParts = [
	$"xo_EMP_CH_MDL_core",
	$"xo_EMP_CH_MDL_ring",
	$"xo_EMP_CH_core_flash",
	$"xo_EMP_CH_debris_glow_1",
	$"xo_EMP_CH_fire_1",
	$"xo_EMP_CH_fire_flat",
	$"xo_EMP_CH_fire_trails_1",
	$"xo_EMP_CH_refrac"
]

const array <asset> empRingPartsSmoke = [
	$"xo_EMP_CH_ring_dust",
	$"xo_EMP_CH_smoke_linger"
]

void function primrosePrecache(){
    #if CLIENT
	foreach(particleAsset in particlesToPrecache)
		PrecacheParticleSystem(particleAsset)
	foreach(particleAsset in empRingParts)
		PrecacheParticleSystem(particleAsset)
	foreach(particleAsset in empRingPartsSmoke)
		PrecacheParticleSystem(particleAsset)
	thread primroseMain()
    #endif
}

#if CLIENT
void function wormholeSwitch(var button){
	entity player = GetLocalClientPlayer()
	if(!IsValid(player) || player == null)
		return
	entity weapon = player.GetActiveWeapon()
	if(!IsValid(weapon) || weapon == null)
		return
	if(weapon.GetWeaponClassName() != "mp_weapon_sniper")
		return
    isA6K = !isA6K
}

vector function GetConVarFloat3(string convar){
    array<string> value = split(GetConVarString(convar), " ")
    try{
        return Vector(value[0].tofloat(), value[1].tofloat(), value[2].tofloat()) 
    }
    catch(ex){
        throw "Invalid convar " + convar + "! make sure it is a float3 and formatted as \"X Y Z\""
    }
    unreachable
}

float function GetKillTime(){
	float conVarValue = GetConVarFloat("s2_primrose_kill_time")
	if(conVarValue > 0)
		return conVarValue
	else{
		throw "S2.Primrose\n\nInvalid input, Kill Colour Transition Time can't be below or equal to 0!"
		SetConVarFloat("s2_primrose_kill_time", 3.0)
	}
	unreachable
}

float function logAnyDecrease(float x, float coefficient){
    if(coefficient > 0.0){
        float k = (1.0/coefficient)
        float b = -(1.0/(pow(2.71828, k) - 1.0))
        float c = (1.0 + (coefficient * log(1.0/(pow(2.71828, k) - 1.0))))
        return ((coefficient * -(log(x - b))) + c)
    }
    else{
        return -1.0
    }
    unreachable
}

float function quadraticDecrease(float x){
    return ((-4 * (x - 0.5) * (x - 0.5)) + 1)
}

float function GetLogCoefficient(){
    float input = GetConVarFloat("s2_primrose_kill_log_coeff")
    if(input > 0)
        return input
    else{
        SetConVarFloat("s2_primrose_kill_log_coeff", 0.5)
        throw "S2.Primrose\n\nInvalid input, Logarithmic Transition Coefficient can't be below or equal to 0!"
    }
    unreachable
}

float function sine2(float x){
	return (0.5 * sin(x) + 0.5)
}

vector function DataKnife_GetTopoRightVectorForSize( vector attachAngles, float topoSize )
{
	vector right = (AnglesToRight( attachAngles ) * -1) * topoSize
	return right
}

vector function DataKnife_GetTopoDownVectorForSize( vector attachAngles, float topoSize )
{
	vector down = (AnglesToUp( attachAngles ) * -1) * topoSize
	return down
}

vector function DataKnife_GetAdjustedTopoOriginForSize( vector centerOrigin, vector attachAngles, float topoSize )
{
	vector newOrg = centerOrigin

	// adjust so the RUI is drawn with centerOrigin as its center point
	newOrg += AnglesToRight( attachAngles ) * (topoSize * 0.5)
	newOrg += AnglesToUp( attachAngles ) * (topoSize * 0.5)

	return newOrg
}

var wormholeConst = null
var indicator = null
var flyout = null
bool isA6K = false
bool hasBlue = true
bool hasRed = false
float killTime = 0.0

int settingBeamDir
int settingKillType
int settingSpecialStyle
int settingModelFire
int settingModelAmmo
int settingModelNeon
float settingModelFireInt
float settingModelAmmoInt
float settingModelNeonInt
float settingModelFireInt2
float settingModelAmmoInt2
float settingModelNeonInt2
float settingAlpha
float settingAdsAlpha
float settingSize
float settingKillTime
float settingKillLogCoeff
float settingSineSpeed
bool settingReload
bool settingShoot
bool settingImpact
bool settingImpactBig
bool settingFlare
bool settingFlyout
bool settingKillBeam
bool settingKillNeon
vector settingModelFireCol
vector settingModelAmmoCol
vector settingModelNeonCol
vector settingModelFireCol2
vector settingModelAmmoCol2
vector settingModelNeonCol2
vector settingPos
vector settingCol

void function primroseMain(){
	RegisterButtonPressedCallback(KEY_Z, wormholeSwitch)
	AddCallback_OnPlayerKilled(primroseKillCallbackFunc)
    wormholeConst = RuiCreate($"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1)
	RuiSetInt(wormholeConst, "maxLines", 1)
	RuiSetInt(wormholeConst, "lineNum", 1)
	RuiSetFloat2(wormholeConst, "msgPos", <0.82, 0.35, 0.0>)
	RuiSetString(wormholeConst, "msgText", "Wormhole:")
	RuiSetFloat(wormholeConst, "msgFontSize", 42.0)
	RuiSetFloat(wormholeConst, "msgAlpha", 0.0)
	RuiSetFloat(wormholeConst, "thicken", 0.0)
	RuiSetFloat3(wormholeConst, "msgColor", <1.0, 0.55, 0.0>)
	indicator = RuiCreate($"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1)
	RuiSetInt(indicator, "maxLines", 1)
	RuiSetInt(indicator, "lineNum", 1)
	RuiSetFloat2(indicator, "msgPos", <0.9245, 0.35, 0.0>)
	RuiSetString(indicator, "msgText", "Base")
	RuiSetFloat(indicator, "msgFontSize", 42.0)
	RuiSetFloat(indicator, "msgAlpha", 0.0)
	RuiSetFloat(indicator, "thicken", 0.0)
	RuiSetFloat3(indicator, "msgColor", <0.1, 0.4, 1.0>)
    while("true"){
        WaitFrame()
		if(IsMenuLevel() || IsLobby())
			continue
        entity player = GetLocalClientPlayer()
		if(player == null || !IsValid(player) || GetLocalViewPlayer() != player){
			RuiSetFloat(wormholeConst, "msgAlpha", 0.0)
			RuiSetFloat(indicator, "msgAlpha", 0.0)
			continue
		}
        entity weapon = player.GetActiveWeapon()
        if (!IsValid(weapon)){
			RuiSetFloat(wormholeConst, "msgAlpha", 0.0)
			RuiSetFloat(indicator, "msgAlpha", 0.0)
			continue
		}
        if(weapon.GetWeaponClassName() == "mp_weapon_sniper"){
			if(GetConVarInt("s2_primrose_kill")){
				killTime = Time()
				SetConVarInt("s2_primrose_kill", 0)/*
				//var sussyTest = RuiCreate($"ui/dataknife_lower_panel.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1)
				int attachID 	= knife.LookupAttachment( attachName )
				vector org 		= knife.GetAttachmentOrigin( attachID )
				vector ang 		= knife.GetAttachmentAngles( attachID )

				float topoSize = DataKnife_GetTopoSizeForAttachName( attachName )
				org = DataKnife_GetAdjustedTopoOriginForSize( org, ang, topoSize )

				// right and down vectors that get added to base org to create the display size
				vector right = DataKnife_GetTopoRightVectorForSize( ang, topoSize )
				vector down = DataKnife_GetTopoDownVectorForSize( ang, topoSize )

				//DebugDrawAngles( org, ang, 10 )
				//DebugDrawAngles( org + right, ang, 10 )
				//DebugDrawAngles( org + down, ang, 10 )

				bool doClipping = false
				var topo = RuiTopology_CreatePlane( org, right, down, doClipping )
				*/
				////////////////////////////////////////////////////////////////////////////////////////////////////
				/*
				int attachID = weapon.LookupAttachment("shell")
				vector org = weapon.GetAttachmentOrigin(attachID)
				vector ang = weapon.GetAttachmentAngles(attachID)
				float topoSize = 100.0
				org = DataKnife_GetAdjustedTopoOriginForSize( org, ang, topoSize )
				vector right = DataKnife_GetTopoRightVectorForSize( ang, topoSize )
				vector down = DataKnife_GetTopoDownVectorForSize( ang, topoSize )
				bool doClipping = false
				//var epicCustomTopo = RuiTopology_CreatePlane( org, right, down, doClipping )
				var epicCustomTopo = RuiTopology_CreatePlane( org, AnglesToRight(ang)*topoSize, AnglesToUp(ang)*topoSize, doClipping )
				var sussyTest = RuiCreate($"ui/dataknife_lower_panel.rpak", epicCustomTopo, RUI_DRAW_COCKPIT, -1)*/
			}
			settingKillTime = GetKillTime()
			settingKillType = GetConVarInt("s2_primrose_kill_type")
			settingKillLogCoeff = GetLogCoefficient()

			settingSineSpeed = GetConVarFloat("s2_primrose_sine_speed")

			settingSpecialStyle = GetConVarInt("s2_primrose_special_style")

			settingModelFire = GetConVarInt("s2_primrose_model_fire_style")
			settingModelFireInt = GetConVarFloat("s2_primrose_model_fire_int")
			settingModelFireCol = GetConVarFloat3("s2_primrose_model_fire_col")
			settingModelFireInt2 = GetConVarFloat("s2_primrose_kill_fire_colour_int")
			settingModelFireCol2 = GetConVarFloat3("s2_primrose_kill_fire_colour")

			settingModelAmmo = GetConVarInt("s2_primrose_model_ammo_style")
			settingModelAmmoInt = GetConVarFloat("s2_primrose_model_ammo_int")
			settingModelAmmoCol = GetConVarFloat3("s2_primrose_model_ammo_col")
			settingModelAmmoInt2 = GetConVarFloat("s2_primrose_kill_ammo_colour_int")
			settingModelAmmoCol2 = GetConVarFloat3("s2_primrose_kill_ammo_colour")

			settingModelNeon = GetConVarInt("s2_primrose_model_neon_style")
			settingModelNeonInt = GetConVarFloat("s2_primrose_model_neon_int")
			settingModelNeonCol = GetConVarFloat3("s2_primrose_model_neon_col")
			settingModelNeonInt2 = GetConVarFloat("s2_primrose_kill_neon_colour_int")
			settingModelNeonCol2 = GetConVarFloat3("s2_primrose_kill_neon_colour")

			settingAlpha = GetConVarFloat("s2_primrose_alpha")
			settingAdsAlpha = GetConVarFloat("s2_primrose_alpha_ads")
			settingSize = GetConVarFloat("s2_primrose_size")
			settingPos = GetConVarFloat3("s2_primrose_pos")
			settingCol = GetConVarFloat3("s2_primrose_col")
			
			settingKillBeam = (GetConVarInt("s2_primrose_beam") == 1)
			settingBeamDir = GetConVarInt("s2_primrose_beam_direction")
			settingReload = (GetConVarInt("s2_primrose_reload_fx") == 1)
			settingShoot = (GetConVarInt("s2_primrose_fire_fx") == 1)
			settingImpact = (GetConVarInt("s2_primrose_impact") == 1)
			settingImpactBig = (GetConVarInt("s2_primrose_impact_big") == 1)
			settingFlare = (GetConVarInt("s2_primrose_impact_flare") == 1)
			settingFlyout = (GetConVarInt("s2_primrose_flyout") == 1)

            entity viewModel = player.GetViewModelEntity()
            RuiSetFloat(indicator, "msgAlpha", settingAlpha)
            RuiSetFloat(wormholeConst, "msgAlpha", settingAlpha)
			float adsFrac = player.GetZoomFrac()
			RuiSetFloat(indicator, "msgAlpha", ((1-adsFrac)*settingAlpha + adsFrac*settingAdsAlpha))
			RuiSetFloat(wormholeConst, "msgAlpha", ((1-adsFrac)*settingAlpha + adsFrac*settingAdsAlpha))
			RuiSetFloat2(indicator, "msgPos", settingPos + (settingSize/42.0 * <0.1045, 0.0, 0.0>))
			RuiSetFloat2(wormholeConst, "msgPos", settingPos)
			RuiSetFloat3(wormholeConst, "msgColor", settingCol)
			RuiSetFloat(indicator, "msgFontSize", settingSize)
			RuiSetFloat(wormholeConst, "msgFontSize", settingSize)
			vector modelFireColour = <0, 0, 0>
			vector modelAmmoColour = <0, 0, 0>
			vector modelNeonColour = <0, 0, 0>
			vector modelFireColour2 = <0, 0, 0>
			vector modelAmmoColour2 = <0, 0, 0>
			vector modelNeonColour2 = <0, 0, 0>
			vector modelFireColourFinal = <0, 0, 0>
			vector modelAmmoColourFinal = <0, 0, 0>
			vector modelNeonColourFinal = <0, 0, 0>
			float modelFireIntFinal = 0.0
			float modelAmmoIntFinal = 0.0
			float modelNeonIntFinal = 0.0
			switch(settingModelFire){
				case 0:
					modelFireColour = (!isA6K ? <0.0, 0.76, 1.0> : <1.0, 0.1, 0.1>)
					modelFireColour2 = (!isA6K ? <0.0, 1.0, 0.65> : <1.0, 0.3, 0.0>)
				break;
				case 1:
					modelFireColour = <0.0, 0.76, 1.0>
					modelFireColour2 = <0.0, 1.0, 0.65>
				break;
				case 2:
					modelFireColour = <1.0, 0.1, 0.1>
					modelFireColour2 = <1.0, 0.3, 0.0>
				break;
				case 3:
					modelFireColour = settingModelFireCol
					modelFireColour2 = settingModelFireCol2
				break;
				case 4:
					modelFireColour.x = sin(Time() * 2)
					modelFireColour.y = sin((Time() + PI/3.0) * 2)
					modelFireColour.z = sin((Time() + 2.0*PI/3.0) * 2)
					modelFireColour2 = modelFireColour
				break;
				case 5:
					modelFireColour = <0, 0, 0>
					modelFireColour2 = <0, 0, 0>
				break;
				default:
					modelFireColour = <0, 0, 0>
					modelFireColour2 = <0, 0, 0>
				break;
			}
			switch(settingModelAmmo){
				case 0:
					modelAmmoColour = (!isA6K ? <0.0, 0.76, 1.0> : <1.0, 0.1, 0.1>)
					modelAmmoColour2 = (!isA6K ? <0.0, 1.0, 0.65> : <1.0, 0.3, 0.0>)
				break;
				case 1:
					modelAmmoColour = <0.0, 0.76, 1.0>
					modelAmmoColour2 = <0.0, 1.0, 0.65>
				break;
				case 2:
					modelAmmoColour = <1.0, 0.1, 0.1>
					modelAmmoColour2 = <1.0, 0.3, 0.0>
				break;
				case 3:
					modelAmmoColour = settingModelAmmoCol
					modelAmmoColour2 = settingModelAmmoCol2
				break;
				case 4:
					modelAmmoColour.x = sin(Time() * 2)
					modelAmmoColour.y = sin((Time() + PI/3.0) * 2)
					modelAmmoColour.z = sin((Time() + 2.0*PI/3.0) * 2)
					modelAmmoColour2 = modelAmmoColour
				break;
				case 5:
					modelAmmoColour = <0, 0, 0>
					modelAmmoColour2 = <0, 0, 0>
				break;
				default:
					modelAmmoColour = <0, 0, 0>
					modelAmmoColour2 = <0, 0, 0>
				break;
			}
			switch(settingModelNeon){
				case 0:
					modelNeonColour = (!isA6K ? <0.0, 0.76, 1.0> : <1.0, 0.1, 0.1>)
					modelNeonColour2 = (!isA6K ? <0.0, 1.0, 0.65> : <1.0, 0.3, 0.0>)
				break;
				case 1:
					modelNeonColour = <0.0, 0.76, 1.0>
					modelNeonColour2 = <0.0, 1.0, 0.65>
				break;
				case 2:
					modelNeonColour = <1.0, 0.1, 0.1>
					modelNeonColour2 = <1.0, 0.3, 0.0>
				break;
				case 3:
					modelNeonColour = settingModelNeonCol
					modelNeonColour2 = settingModelNeonCol2
				break;
				case 4:
					modelNeonColour.x = sin(Time() * 2)
					modelNeonColour.y = sin((Time() + PI/3.0) * 2)
					modelNeonColour.z = sin((Time() + 2.0*PI/3.0) * 2)
					modelNeonColour2 = modelNeonColour
				break;
				case 5:
					modelNeonColour = <0, 0, 0>
					modelNeonColour2 = <0, 0, 0>
				break;
				default:
					modelNeonColour = <0, 0, 0>
					modelNeonColour2 = <0, 0, 0>
				break;
			}
			if(settingSpecialStyle == 0){
				modelFireColourFinal = modelFireColour
				modelAmmoColourFinal = modelAmmoColour
				modelNeonColourFinal = modelNeonColour
				modelFireIntFinal = settingModelFireInt
				modelAmmoIntFinal = settingModelAmmoInt
				modelNeonIntFinal = settingModelNeonInt
			}
			else if(settingSpecialStyle == 1){
				float sineVal = sine2(settingSineSpeed * Time())
				modelFireColourFinal = ((sineVal*modelFireColour2) + ((1 - sineVal)*modelFireColour))
				modelAmmoColourFinal = ((sineVal*modelAmmoColour2) + ((1 - sineVal)*modelAmmoColour))
				modelNeonColourFinal = ((sineVal*modelNeonColour2) + ((1 - sineVal)*modelNeonColour))

				modelFireIntFinal = sineVal*settingModelFireInt2 + (1 - sineVal)*settingModelFireInt
				modelAmmoIntFinal = sineVal*settingModelAmmoInt2 + (1 - sineVal)*settingModelAmmoInt
				modelNeonIntFinal = sineVal*settingModelNeonInt2 + (1 - sineVal)*settingModelNeonInt
			}
			else{
				float elapsedTime = Time() - killTime
				if(elapsedTime <= settingKillTime){
					float timeFrac = (elapsedTime/settingKillTime)
					float transFraction = settingKillType == 0 ? timeFrac : (settingKillType == 1 ? quadraticDecrease(timeFrac) : logAnyDecrease(timeFrac, settingKillLogCoeff))
					modelFireColourFinal = ((transFraction*modelFireColour2) + ((1 - transFraction)*modelFireColour))
					modelAmmoColourFinal = ((transFraction*modelAmmoColour2) + ((1 - transFraction)*modelAmmoColour))
					modelNeonColourFinal = ((transFraction*modelNeonColour2) + ((1 - transFraction)*modelNeonColour))

					modelFireIntFinal = transFraction*settingModelFireInt2 + (1 - transFraction)*settingModelFireInt
					modelAmmoIntFinal = transFraction*settingModelAmmoInt2 + (1 - transFraction)*settingModelAmmoInt
					modelNeonIntFinal = transFraction*settingModelNeonInt2 + (1 - transFraction)*settingModelNeonInt
				}
				else{
					modelFireColourFinal = modelFireColour
					modelAmmoColourFinal = modelAmmoColour
					modelNeonColourFinal = modelNeonColour
					modelFireIntFinal = settingModelFireInt
					modelAmmoIntFinal = settingModelAmmoInt
					modelNeonIntFinal = settingModelNeonInt
				}
			}
			modelFireColourFinal *= modelFireIntFinal
			modelAmmoColourFinal *= modelAmmoIntFinal
			modelNeonColourFinal *= modelNeonIntFinal
			SetConVarFloat("s2_primrose_fire_r", modelFireColourFinal.x)
			SetConVarFloat("s2_primrose_fire_g", modelFireColourFinal.y)
			SetConVarFloat("s2_primrose_fire_b", modelFireColourFinal.z)
			SetConVarFloat("s2_primrose_ammo_r", modelAmmoColourFinal.x)
			SetConVarFloat("s2_primrose_ammo_g", modelAmmoColourFinal.y)
			SetConVarFloat("s2_primrose_ammo_b", modelAmmoColourFinal.z)
			SetConVarFloat("s2_primrose_neon_r", modelNeonColourFinal.x)
			SetConVarFloat("s2_primrose_neon_g", modelNeonColourFinal.y)
			SetConVarFloat("s2_primrose_neon_b", modelNeonColourFinal.z)
            if(!isA6K && !hasBlue){
				RuiSetFloat3(indicator, "msgColor", <0.1, 0.4, 1.0>)
                RuiSetString(indicator, "msgText", "Base")
                weapon.EmitWeaponSound_1p3p("weapon_coldwar_chargeup_1p", "")
		        weapon.EmitWeaponSound_1p3p("weapon_smartpistol_slideback", "")
				if(settingFlyout){
					flyout = null
					flyout = CreateCockpitRui($"ui/weapon_flyout.rpak")
					RuiSetGameTime(flyout, "startTime", Time())
					RuiSetFloat(flyout, "duration", 3.0)
					RuiSetBool(flyout, "showWeaponXP", false)
					RuiSetFloat3(flyout, "color", <0.1, 0.4, 1.0>)
					RuiSetString(flyout, "titleText", "`2Baseline Reality`0")
					RuiSetString(flyout, "descriptionText", "Baseline matter is ionised and propelled.")
					RuiSetFloat(flyout, "underlineHeight", 4.0)
					RuiSetFloat(flyout, "underlineWidth", 4.0)
					RuiTrackFloat3(flyout, "pos", viewModel, RUI_TRACK_POINT_FOLLOW, viewModel.LookupAttachment("flyout"))
				}
                hasBlue = true
                hasRed = false
            }
            if(isA6K && !hasRed){
				RuiSetFloat3(indicator, "msgColor", <1.0, 0.1, 0.1>)
				RuiSetString(indicator, "msgText", "A6K")
				weapon.EmitWeaponSound_1p3p("weapon_coldwar_chargeup_1p", "")
				weapon.EmitWeaponSound_1p3p("weapon_smartpistol_slideback", "")
				if(settingFlyout){
					flyout = null
					flyout = CreateCockpitRui($"ui/weapon_flyout.rpak")
					RuiSetGameTime(flyout, "startTime", Time())
					RuiSetFloat(flyout, "duration", 3.0)
					RuiSetBool(flyout, "showWeaponXP", false)
					RuiSetFloat3(flyout, "color", <1.0, 0.1, 0.1>)
					RuiSetString(flyout, "titleText", "`2A6K 'Parallel' Dimension`0")
					RuiSetString(flyout, "descriptionText", "A6K's particles are transferred and accelerated.")
					RuiSetFloat(flyout, "underlineHeight", 4.0)
					RuiSetFloat(flyout, "underlineWidth", 4.0)
					RuiTrackFloat3(flyout, "pos", viewModel, RUI_TRACK_POINT_FOLLOW, viewModel.LookupAttachment("flyout"))
				}
                hasBlue = false
                hasRed = true
            }
        }
        else{
            RuiSetFloat(indicator, "msgAlpha", 0.0)
            RuiSetFloat(wormholeConst, "msgAlpha", 0.0)
        }
    }
}

void function primroseKillCallbackFunc(ObituaryCallbackParams inputParams){
	if(!IsValid(inputParams.attacker) || inputParams.attacker == null)
		return
	entity player = GetLocalClientPlayer()
	if(!IsValid(player) || player == null)
		return
	if(inputParams.attacker != player)
		return
	entity weapon = player.GetActiveWeapon()
	if(!IsValid(weapon) || weapon == null)
		return
	if(DamageSourceIDToString(inputParams.damageSourceId) != "mp_weapon_sniper")
		return
	//if(settingKill)
		//thread viewmodelKillFX(weapon, attacker, ((player.GetZoomFrac() > 0.5) ? 0.15 : 0.0))
	if(settingKillBeam)
		thread killBeam(inputParams.victim.GetOrigin(), player.EyeAngles())
	if(settingKillNeon)
		killTime = Time()
}

void function viewmodelKillFX(entity weapon, entity player, float delayTime){
	if(delayTime > 0.0)
		Wait(delayTime)
	if(!IsValid(player) || player == null || !IsValid(weapon) || weapon == null)
		return
	if(player.GetZoomFrac() > 0.5)
		return
	if(!isA6K){
		weapon.PlayWeaponEffect($"P_wpn_mflash_dbltake_FP_burn", $"", "muzzle_flash")
	}
	else{
		weapon.PlayWeaponEffect($"P_impact_dragonbreath", $"", "shell")
	}
}

void function killBeam(vector victimPos, vector playerAng){
	int fxHandle = StartParticleEffectInWorldWithHandle(GetParticleSystemIndex($"wpn_arc_cannon_beam"), victimPos, playerAng)
	while(EffectDoesExist(fxHandle)){
		entity player = GetLocalClientPlayer()
		if(!IsValid(player) || player == null)
			break
		entity weapon = player.GetActiveWeapon()
		if(!IsValid(weapon) || weapon == null)
			break
		if(weapon.GetWeaponClassName() != "mp_weapon_sniper")
			break
		vector muzzleOrigin = weapon.GetAttachmentOrigin(weapon.LookupAttachment("muzzle_flash"))
		EffectSetControlPointVector(fxHandle, (1 - settingBeamDir), victimPos)
		EffectSetControlPointVector(fxHandle, settingBeamDir, muzzleOrigin)
		WaitFrame()
	}
}

#endif

var function OnWeaponPrimaryAttack_weapon_primrose(entity weapon, WeaponPrimaryAttackParams attackParams){
	weapon.EmitWeaponNpcSound( LOUD_WEAPON_AI_SOUND_RADIUS_MP, 0.2 )
	#if CLIENT
		if(!isA6K){
			weapon.EmitWeaponSound_1p3p("Weapon_HemlokSMG_Single_1P", "")
			weapon.EmitWeaponSound_1p3p("weapon_kraber_fire_1p", "")
			weapon.EmitWeaponSound_1p3p("weapon_batterygun_firestart_1p", "")
			weapon.PlayWeaponEffect($"wpn_muzzleflash_xo_elec_FP", $"", "muzzle_flash")
		}
		else{
			weapon.EmitWeaponSound_1p3p("weapon_titan_sniper_level_1_1p", "")
			weapon.EmitWeaponSound_1p3p("weapon_g2a4_fire_1p", "")
			weapon.PlayWeaponEffect( $"P_muz_lstar_FP", $"", "muzzle_flash" )
		}
	#endif
	return FireWeaponPlayerAndNPC( weapon, attackParams, true )
}

int function FireWeaponPlayerAndNPC( entity weapon, WeaponPrimaryAttackParams attackParams, bool playerFired )
{
	bool shouldCreateProjectile = false
	if(IsServer() || weapon.ShouldPredictProjectiles())
		shouldCreateProjectile = true

	#if CLIENT
		if(!playerFired)
			shouldCreateProjectile = false
	#endif

	if (shouldCreateProjectile){
		int boltSpeed = expect int( weapon.GetWeaponInfoFileKeyField( "bolt_speed" ) )
		int damageFlags = weapon.GetWeaponDamageFlags()
		entity bolt = weapon.FireWeaponBolt( attackParams.pos, attackParams.dir, boltSpeed, damageFlags, damageFlags, playerFired, 0 )
		if ( bolt != null ){
			bolt.kv.gravity = expect float( weapon.GetWeaponInfoFileKeyField( "bolt_gravity_amount" ) )
			StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"weapon_kraber_projectile"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
			#if CLIENT
			if(settingShoot){
				StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"titan_sniper_CH_refract"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
				StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"titan_sniper_CH_refract"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
				StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"titan_sniper_CH_rope_smoke"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
				if(!isA6K){
					StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"titan_sniper_CH_trail_arc"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
					StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"wpn_grenade_frag_blue"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
					StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"P_doubletake_proj"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
					StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"P_wpn_mflash_dbltake_FP_burn"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
				}
				else{
					StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"P_proj_predator_alt_pwr"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
					StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"P_projectile_lstar"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
				}
			}/*
			if(settingBoltLight){
				thread boltLighting(bolt)
				//local boltAmbientLight = CreateClientSideDynamicLight( bolt.GetOrigin(), <0, 90, 0>, (isA6K ? < 1.0, 0.1, 0.1> : <0.4, 0.7, 1.0>), 500 )
				//boltAmbientLight.SetParent(bolt)
			}*/
			#endif
		}
	}

	return 1
}

#if CLIENT
void function boltLighting(entity bolt){
	local boltAmbientLight = CreateClientSideDynamicLight( bolt.GetOrigin() + <0, 0, 50>, <0, 0, 0>, 10 * (isA6K ? < 1.0, 0.1, 0.1> : <0.4, 0.7, 1.0>), 500 )
	while(IsValid(bolt)){
		//printt("[S2.Primrose] Bolt is valid!")
		boltAmbientLight.SetLightColor(10*(isA6K ? < 1.0, 0.1, 0.1> : <0.4, 0.7, 1.0>))
		boltAmbientLight.SetOrigin(bolt.GetOrigin() + <0, 0, 50>)
		WaitFrame()
	}
	boltAmbientLight.Destroy()
	boltAmbientLight = null
}
#endif

void function OnProjectileCollision_weapon_primrose(entity projectile, vector pos, vector normal, entity hitEnt, int hitbox, bool isCritical){
	#if CLIENT
	vector normalAng = VectorToAngles(normal)
	if(settingImpact){
		if(!isA6K){
			StartParticleEffectInWorld(GetParticleSystemIndex($"wpn_muzzleflash_arc_cannon_fp"), pos, normalAng)
			StartParticleEffectInWorld(GetParticleSystemIndex($"P_xo_armor_impact"), pos, normalAng)
			if(settingImpactBig){
				foreach(particleAsset in empRingParts)
					StartParticleEffectInWorld(GetParticleSystemIndex(particleAsset), pos, (normalAng + <90, 0, 0>))
				//StartParticleEffectInWorld(GetParticleSystemIndex($"impact_arc_cannon_titan"), (pos + <0, 20, 0 >), <90, 0, 0>)
			}
		}
		else{
			StartParticleEffectInWorld(GetParticleSystemIndex($"P_muz_TPA"), pos, normalAng)
			StartParticleEffectInWorld(GetParticleSystemIndex($"impact_ArcCannon_CH_bits_red"), pos, normalAng)
			StartParticleEffectInWorld(GetParticleSystemIndex($"impact_ArcCannon_CH_glow_FP_red"), pos, <90, 0, 0>)
			if(settingImpactBig){
				foreach(particleAsset in empRingPartsSmoke)
					StartParticleEffectInWorld(GetParticleSystemIndex(particleAsset), pos, (normalAng + <90, 0, 0>))
				StartParticleEffectInWorld(GetParticleSystemIndex($"xo_EMP_CH_refrac"), pos, (normalAng + <90, 0, 0>))
				StartParticleEffectInWorld(GetParticleSystemIndex($"P_impact_lasercannon_default"), pos, normalAng)
			}
		}
	}
	if(settingFlare)
		thread lastingImpact(pos, normalAng, (isA6K ? 0 : 1))
	#endif
	#if SERVER
		int bounceCount = projectile.GetProjectileWeaponSettingInt( eWeaponVar.projectile_ricochet_max_count )
		if ( projectile.proj.projectileBounceCount >= bounceCount )
			return

		if ( hitEnt == svGlobal.worldspawn )
			EmitSoundAtPosition( TEAM_UNASSIGNED, pos, "Bullets.DefaultNearmiss" )

		projectile.proj.projectileBounceCount++
	#endif
}

#if CLIENT
void function lastingImpact(vector pos, vector ang, int mode){
	int fxHandle = StartParticleEffectInWorldWithHandle(GetParticleSystemIndex(projectileTrails[mode]), pos, Vector(-ang.x, (ang.y + 180.0), ang.z))
	wait 1.5
	if(EffectDoesExist(fxHandle))
		EffectStop(fxHandle, true, true)
	StartParticleEffectInWorld(GetParticleSystemIndex(muzzleFlashes[mode]), pos, ang)
}
#endif

void function OnWeaponReload_weapon_primrose(entity weapon, int milestoneIndex){
	#if CLIENT
	if(settingReload){
		/*
		weapon.PlayWeaponEffect($"xo_spark_med", $"", "shell")
		weapon.PlayWeaponEffect($"xo_spark_med", $"", "muzzle_flash")
		if(!isA6K){
			weapon.PlayWeaponEffect($"P_emp_body_human", $"", "shell")
			weapon.PlayWeaponEffect($"P_wpn_charge_coldwar_FP", $"", "shell")
			weapon.PlayWeaponEffect($"wpn_muzzleflash_arc_cannon_fp", $"", "muzzle_flash")
			weapon.PlayWeaponEffect($"P_doubletake_proj", $"", "muzzle_flash")
			weapon.PlayWeaponEffect($"P_wpn_mflash_arcball", $"", "muzzle_flash")
			weapon.PlayWeaponEffect($"P_wpn_mflash_arcball", $"", "shell")
		}
		else{
			weapon.PlayWeaponEffect($"lstar_trail_CH_spark", $"", "muzzle_flash")
			weapon.PlayWeaponEffect($"P_muz_lstar", $"", "shell")
			weapon.PlayWeaponEffect($"P_impact_lstar_default", $"", "muzzle_flash")
			weapon.PlayWeaponEffect($"impact_ArcCannon_CH_glow_P_red", $"", "shell")
			//weapon.PlayWeaponEffect($"primrose_sprite_vortex", $"", "muzzle_flash")
			//StartParticleEffectOnEntity(weapon, GetParticleSystemIndex($"primrose_sprite_vortex"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
		}
		*/
		weapon.PlayWeaponEffect($"P_emp_body_human", $"", "shell")
		weapon.PlayWeaponEffect($"P_wpn_charge_coldwar_FP", $"", "shell")
		weapon.PlayWeaponEffect($"wpn_muzzleflash_arc_cannon_fp", $"", "muzzle_flash")
		weapon.PlayWeaponEffect($"xo_spark_med", $"", "shell")
		weapon.PlayWeaponEffect($"xo_spark_med", $"", "muzzle_flash")
		weapon.PlayWeaponEffect($"P_doubletake_proj", $"", "muzzle_flash")
		weapon.PlayWeaponEffect($"P_wpn_mflash_arcball", $"", "muzzle_flash")
		weapon.PlayWeaponEffect($"P_wpn_mflash_arcball", $"", "shell")
		weapon.EmitWeaponSound_1p3p("LSTAR_LensBurnout", "")
		weapon.EmitWeaponSound_1p3p("LSTAR_VentCooldown", "")
		weapon.EmitWeaponSound_1p3p("Weapon_Titan_Sniper_SustainLoop", "")
		weapon.EmitWeaponSound_1p3p("wpn_Thunderbolt_ADS_In_1P", "")
		weapon.EmitWeaponSound_1p3p("wpn_Thunderbolt_ADS_Out_1P", "")
		thread DelayedStopEffect(weapon, (weapon.HasMod("pas_fast_reload") ? 1.0 : 1.5), (isA6K ? true : false))
	}
	#endif
}

void function DelayedStopEffect(entity weapon, float delayTime, bool delayIsA6K){
	#if CLIENT
	Wait(delayTime)
	if(IsValid(weapon)){
		/*
		if(!delayIsA6K){
			weapon.StopWeaponEffect($"P_emp_body_human", $"")
			weapon.StopWeaponEffect($"P_wpn_charge_coldwar_FP", $"")
			weapon.StopWeaponEffect($"P_doubletake_proj", $"")
		}
		else{
			weapon.StopWeaponEffect($"lstar_trail_CH_spark", $"")
		}
		*/
		weapon.StopWeaponEffect($"P_emp_body_human", $"")
		weapon.StopWeaponEffect($"P_wpn_charge_coldwar_FP", $"")
		weapon.StopWeaponEffect($"P_doubletake_proj", $"")
		FadeOutSoundOnEntity(weapon, "Weapon_Titan_Sniper_SustainLoop", 0.5)
	}
	#endif
}